package com.adamatomic.Mode
{
	import org.flixel.*;
	import flash.geom.Rectangle;
	import flash.display.BitmapData;

	public class MenuState extends FlxState
	{
		[Embed(source="../../../data/titletemplate.png")] static public var ImgTitle:Class;
		[Embed(source="../../../data/cursor.png")] static public var ImgCursor:Class;
		[Embed(source="../../../data/blip1.mp3")] static public var SndBlip:Class;
		[Embed(source="../../../data/blip2.mp3")] static public var SndBang:Class;
		[Embed(source="../../../data/title.mp3")] static public var SndTitle:Class;
		[Embed(source="../../../data/gamemusic.mp3")] static public var SndGame:Class;
		
		private var _b:FlxButton;
		private var _t3:FlxText;
		private var _t4:FlxText;
		private var _ok:Boolean;
		private var _ok2:Boolean;
		private var _ok3:Boolean;
		private var mt:MersenneTwister;
		private var elapsed:Number;
		private var _title:FlxSprite;
		
		override public function create():void
		{
			_title = new FlxSprite(0, 0, ImgTitle);

			var s:FlxSprite;
			mt = new MersenneTwister();
			mt.seed = 0;
			elapsed = 0;
			screen = new Vector.<Vector.<int>>;
			
			for (var i:int = 0; i < PlayState.displayheight; i++)
			{
				var row:Vector.<int> = new Vector.<int>;
				
				for (var j:int = 0; j < PlayState.displaywidth ; j++)
				{
					row.push(0);
				}
				screen.push(row);
			}
			updatebackground();
			
			FlxG.playMusic(SndTitle,0.5);
			
			
			_ok = false;
			_ok2 = false;
			
			FlxG.mouse.show(ImgCursor);
			
			//Simple use of flixel save game object
			var save:FlxSave = new FlxSave();
			if(save.bind("Mode"))
			{
				if(save.data.plays == null)
					save.data.plays = 0;
				else
					save.data.plays++;
				FlxG.log("Number of plays: "+save.data.plays);
			}
			
				//explosion
				_ok = true;
				
				var t1:FlxText;
				var t2:FlxText;
				var b:FlxButton;
				
				_t3 = new FlxText(10,FlxG.height/3-60,110,"by increpare")
				_t3.alignment = "center";
				_t3.color = 0x3a5c39;
				
				//play button
				_t4 = new FlxText(0,FlxG.height*2.0/3.0,FlxG.width,"PRESS SPACE TO START.");
				_t4.color = 0xffffffff;
				_t4.alignment = "center";
				_t4.antialiasing = true;
				_t4.size = 16;
				add(_t4);
		}

		override public function update():void
		{
			elapsed += FlxG.elapsed;
			if (elapsed > 0.8)
			{
				elapsed = 0;
				updatebackground();
			}
			
			//X + C were pressed, fade out and change to play state
			if( _ok && !_ok2 && FlxG.keys.justPressed("SPACE") )
			{
				_ok2 = true;
				_t3.visible = false;
				//_t4.visible = false;
				var t:FlxText;
				t = new FlxText(0, 20, FlxG.width, "Rules");
				t.size = 64;
				t.antialiasing = false;
				t.alignment = "center";
				t.color = 0xffffffff;
				add(t);
				t = new FlxText(10, 150, FlxG.width-20, "There are seventeen million bodies to the west.  They must be buried in pits to the east.");
				t.size = 32;
				t.antialiasing = false;
				t.alignment = "center";
				t.color = 0xffffffff;
				add(t);
				updatebackground();
				FlxG.play(SndBang);
			}
			else if (_ok && _ok2 && !_ok3 && FlxG.keys.justPressed("SPACE") )
			{
				_ok3 = true;
				FlxG.play(SndBang);
				FlxG.flash.start(0xff000000,0.5);
				FlxG.fade.start(0xff000000,1,onFade);
			}
			
			super.update();
			drawbackground();
		}
				
		
		private var screen:Vector.<Vector.<int>>;

		private function updatebackground():void
		{
			for (var i:int = 0; i < PlayState.displayheight; i++)
			{		
				for (var j:int = 0; j < PlayState.displaywidth ; j++)
				{				
					if (!_ok2&&_title.pixels.getPixel(j, i) != 0xffffff)
					{
						screen[i][j] = 0xffffffff;
					}
					else
					{
						var n:int = Math.random();
						if ( mt.int32 % PlayState.displaywidth > j)
						{
							if (mt.int32 % 2 == 0)
							{
								screen[i][j] = 0xff664422 ;
							}
							else
							{
								screen[i][j] = 0xff443322 ;							
							}
						}
						else
						{
							if (mt.int32 % 2 == 0)
							{
								screen[i][j] = 0xff444411  ;
							}
							else
							{
								screen[i][j] = 0xff223300 ;							
							}						
						}
					}
				}
			}			
		}
		
		private function drawbackground():void
		{
			var r:Rectangle = new Rectangle;
			r.width = PlayState.tilesize;
			r.height = PlayState.tilesize;
			var bData:BitmapData = FlxG.buffer;
			
			if (!bData)
				return;
				
			for (var i:int = 0; i < PlayState.displaywidth; i++)
			{
				for (var j:int = 0; j < PlayState.displayheight; j++)
				{
					r.x = i * PlayState.tilesize;
					r.y = j * PlayState.tilesize;
						
					bData.fillRect(r, screen[j][i]);
				}
			}
		}
		
		private function onFade():void
		{
			FlxG.state = new PlayState();
			//FlxG.state = new PlayStateTiles();
		}
	}
}



/*
Code orignally written by Ger Hobolt
Available at http://flashexperiments.insh-allah.com/

I simply put it into a Class file to make it easier to use


Function:    MersenneTwister()
Description: Initializes the class
Example:     var mt:MersenneTwister = new MersenneTwister()


Function:    seedMT(seed)
Description: Sets the seed to be used. If the same seed
             is used twice, the same numbers will show up.
			 This function also makes the seed odd to help
			 better generate numbers.
Example:     var mt:MersenneTwister = new MersenneTwister()
             mt.seedMT(5)
			 
			 
Function:    reloadMT()
Description: Called internally, you shouldn't need to use this yourself.


Function:    randomMT()
Description: Returns unscaled random numbers
Example:     var mt:MersenneTwister = new MersenneTwister()
             mt.seedMT(5)
			 trace(mt.randomMT())
			 //The output is 530851887
			 
			 
Function:    rangedMT(low, high)
Description: Returns whole numbers between (and
			 including) the low and high inputs.
Example:     var mt:MersenneTwister = new MersenneTwister()
             mt.seedMT(9)
			 for (var i=0;i<5;i++) {
			 	trace(mt.rangedMT(0, 3))
			 }
			 //The output is 2
							 1
							 3
							 2
							 0
							 
			 
*/

class MersenneTwister
{
	protected static const 
		N:int = 624,
		M:int = 397,
		MATRIX_A:uint = 0x9908b0df,
		UPPER_MASK:uint = 0x80000000,
		LOWER_MASK:uint = 0x7fffffff;

	protected var
		mt:Vector.<uint> = new Vector.<uint>(N),
		mti:int = N+1,
		mag01:Array = [0, MATRIX_A],
		s:uint,
		rangeStart:uint = 0,
		rangeEnd:uint = 0;

	/**
	 * constructor
	 * 
	 * @param seed the random seed
	 */
	public function set seed(seed:uint):void
	{
		initialize(seed);
		s = seed;
	}
	
	/**
	 * sets the range to be used
	 * 
	 * must be set before using 'ranged' to get random numbers
	 *
	 * @param min the range start
	 * @param max the range end
	 */
	public function setRange(min:uint, max:uint):void
	{
		if(min >= max)
			throw new Error('min can not be greater or equal to max');

		rangeStart = min;
		rangeEnd = max-min+1;
	}
	
	/**
	 * initializes mt[N] with a seed
	 * 
	 * @param seed the random seed
	 */
	protected function initialize(seed:uint):void
	{
		mt[0] = seed & 0xffffffff;
		for(mti=1; mti<N; mti++)
		{
			mt[mti] = (1812433253 * (mt[mti-1] ^ (mt[mti-1] >> 30)) + mti); 
			mt[mti] &= 0xffffffff;
		}
	}

	/**
	 * generates a random number between 0 and 0xffffffff
	 * 
	 * @return random int number
	 */
	public function get int32():uint
	{
		var y:uint;

		// generates N numbers at once every N numbers
		if(mti >= N)
		{
			var kk:int;
			
			for(kk=0;kk<N-M;kk++)
			{
				y = (mt[kk] & UPPER_MASK) | (mt[kk+1] & LOWER_MASK);
				mt[kk] = mt[kk+M] ^ (y >> 1) ^ mag01[y & 0x1];
			}
			for (;kk<N-1;kk++)
			{
				y = (mt[kk] & UPPER_MASK) | (mt[kk+1] & LOWER_MASK);
				mt[kk] = mt[kk+(M-N)] ^ (y >> 1) ^ mag01[y & 0x1];
			}
			y = (mt[N-1] & UPPER_MASK) | (mt[0] & LOWER_MASK);
			mt[N-1] = mt[M-1] ^ (y >> 1) ^ mag01[y & 0x1];
			
			// resets counter
			mti = 0;
		}

		y = mt[mti++];
	
		// tempering
		y ^= (y >> 11);
		y ^= (y << 7) & 0x9d2c5680;
		y ^= (y << 15) & 0xefc60000;
		y ^= (y >> 18);

		return y;
	}

	/**
	 * generates a random number between 0 and 1
	 *
	 * takes an int32 random number and divides it by 2^(32-1),
	 * this might not be very right but it should still be acceptable 
	 * for most usages
	 *
	 * @return random float number
	 */
	public function get float():Number
	{
		return int32/2147483647;
	}
	
	/**
	 * generates a random number comprised in the user defined range
	 * 
	 * @return random int number
	 */
	public function get ranged():uint
	{
		return rangeStart + float * rangeEnd;
	}

	/**
	 * the seed set in the constructor, read-only
	 * 
	 * @return the seed used to generate the numbers
	 */
	public function get seed():uint
	{
		return s;
	}
}