package com.adamatomic.Mode
{
	import org.flixel.*;

	public class MenuState extends FlxState
	{
		[Embed(source="../../../data/background.png")] static public var ImgBackground:Class;
		[Embed(source="../../../data/cursor.png")] static public var ImgCursor:Class;
		[Embed(source="../../../data/particles.png")] static public var ImgParticles:Class;
		[Embed(source="../../../data/particles2.png")] static public var ImgParticles2:Class;
		[Embed(source="../../../data/blip.mp3")] static public var SndBlip:Class;
		[Embed(source="../../../data/bang.mp3")] static public var SndBang:Class;
		[Embed(source="../../../data/title.mp3")] static public var SndTitle:Class;
		[Embed(source="../../../data/game.mp3")] static public var SndGame:Class;
		
		private var _bg:FlxSprite;
		private var _b:FlxButton;
		private var _t1:FlxText;
		private var _t2:FlxText;
		private var _t3:FlxText;
		private var _t4:FlxText;
		private var _ok:Boolean;
		private var _ok2:Boolean;
		private var _ok3:Boolean;
		
		override public function create():void
		{
			var i:uint;
			var s:FlxSprite;
			
			FlxG.playMusic(SndTitle,0.5);
			
			_bg = new FlxSprite(0, 0, ImgBackground);
			add(_bg);
			
			_t1 = new FlxText(0,FlxG.height/2-10,FlxG.width,"beating off");
			_t1.size = 15;
			_t1.color = 0x4d5555;
			_t1.antialiasing = true;
			_t1.alignment = "center";
			add(_t1);

			_t2 = new FlxText(0,FlxG.height/2-10-2,FlxG.width,"beating off");
			_t2.size = _t1.size;
			_t2.color = 0x675555;
			_t2.antialiasing = _t1.antialiasing;;
			_t2.alignment = "center";
			add(_t2);
			
			_ok = false;
			_ok2 = false;
			
			FlxG.mouse.show(ImgCursor);
			
			//Simple use of flixel save game object
			var save:FlxSave = new FlxSave();
			if(save.bind("Mode"))
			{
				if(save.data.plays == null)
					save.data.plays = 0;
				else
					save.data.plays++;
				FlxG.log("Number of plays: "+save.data.plays);
			}
			
				//explosion
				_ok = true;
				
				var t1:FlxText;
				var t2:FlxText;
				var b:FlxButton;
				
				_t3 = new FlxText(10,FlxG.height/3-60,110,"by increpare")
				_t3.alignment = "center";
				_t3.color = 0x3a5c39;
				add(_t1);
				
				//play button
				_t4 = new FlxText(0,FlxG.height-30,FlxG.width,"PRESS 4+7 TO PLAY.");
				_t4.color = 0x4d5555;
				_t4.alignment = "center";
				_t4.antialiasing = true;
				add(_t4);
		}

		override public function update():void
		{
			//X + C were pressed, fade out and change to play state
			if(_ok && !_ok2 && (FlxG.keys.justPressed("FOUR") && FlxG.keys.SEVEN || FlxG.keys.FOUR && FlxG.keys.justPressed("SEVEN") )  )
			{
				_ok2 = true;
				_t1.visible = false;
				_t2.visible = false;
				_t3.visible = false;
				//_t4.visible = false;
				var t:FlxText;
				t = new FlxText(0, 10, FlxG.width, "Rules");
				t.size = 17;
				t.antialiasing = false;
				t.alignment = "center";
				t.color = 0x675555;
				add(t);
				t = new FlxText(0, 30, FlxG.width, "press the number indicated when a square crosses over the border.");
				t.size = 8;
				t.antialiasing = false;
				t.alignment = "center";
				t.color = 0x675555;
				add(t);
				t = new FlxText(0, FlxG.height-50-8, FlxG.width, "press the number indicated when a square crosses over the border.");
				t.size = 8;
				t.antialiasing = false;
				t.alignment = "center";
				t.color = 0x4d5555;
				add(t);
				FlxG.play(SndBang);
			}
			else if (_ok && _ok2 && !_ok3 &&  (FlxG.keys.justPressed("FOUR") && FlxG.keys.SEVEN || FlxG.keys.FOUR && FlxG.keys.justPressed("SEVEN") ))
			{
				_ok3 = true;
				FlxG.play(SndBang);
				FlxG.flash.start(0xffd8eba2,0.5);
				FlxG.fade.start(0xff131c1b,1,onFade);
			}

			super.update();
		}
				
		private function onFade():void
		{
			FlxG.state = new PlayState();
			//FlxG.state = new PlayStateTiles();
		}
	}
}
